/* strutil.c
 *
 * Copyright (C) 2000-2003, Christopher Collins <ccollins@ug.cs.usyd.edu.au>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *                                                                             
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *                                                                             
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "strutil.h"

extern void
strtrim(char *in)
{
	char *	dup;
	int		ctr = 0, ctr2 = 0;
	int		position = -1;  /* < 0 == start of string.  > 0 == position of last non-whitespace. */

	dup = strdup(in);
	if (NULL == dup) {
		return;
	}
	for (ctr = 0; dup[ctr] != '\0'; ctr++) {
		if (!isspace(dup[ctr])) {
			position = ctr2;
			in[ctr2++] = dup[ctr];
		} else {
			/* it is space */
			if (position >= 0) {
				/* duplicate this space though... */
				in[ctr2++] = dup[ctr];
			}
		}
	}
	/* string is finished.  set endpoint. */
	in[position + 1] = '\0';

	/* free dup-string */
	free (dup);

	return;
}

extern void
strlcase(char *str)
{
	int	i;
	for (i = 0; str[i] != '\0'; i++) {
		if (isupper(str[i])) {
			str[i] += 'a' - 'A';
		}
	}
	return;
}
